import gevent
from gevent import monkey
monkey.patch_socket()

import bz2
import threading
from urllib.request import urlopen, Request

HEADERS = {'User-Agent': "Mozilla/5.0 Gecko Firefox"}


class Decompressor(threading.Thread):
    def __init__(self, compressed, n):
        super(Decompressor, self).__init__()
        self.compressed = compressed
        self.n = n

    def run(self):
        data = bz2.decompress(self.compressed)
        print("Decompressed", self.n, len(data))


def worker(n):
    url = "http://www.taniquetil.com.ar/testfiles/tf{}.bz2".format(n)
    print("Start", n)
    u = urlopen(Request(url, headers=HEADERS))
    print("Opened", n)
    compressed = u.read()
    print("Read", n)
    th = Decompressor(compressed, n)
    threads.append(th)
    th.start()


threads = []
jobs = []
for i in range(10):
    j = gevent.spawn(worker, i)
    jobs.append(j)
for th in threads:
    th.join()
gevent.joinall(jobs)
print("Done")
